Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 713528 - sys-libs/liburing-0.5 : ../.../liburing.h: error: unknown type name mode_t
Summary: sys-libs/liburing-0.5 : ../.../liburing.h: error: unknown type name mode_t
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Assignee: Gentoo musl team
URL:
Whiteboard: missing sys/stat.h
Keywords:
Depends on:
Blocks: missing-musl-includes
  Show dependency tree
 
Reported: 2020-03-19 19:52 UTC by Toralf Förster
Modified: 2021-03-12 15:06 UTC (History)
2 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
emerge-info.txt (emerge-info.txt,16.42 KB, text/plain)
2020-03-19 19:52 UTC, Toralf Förster
Details
emerge-history.txt (emerge-history.txt,160.55 KB, text/plain)
2020-03-19 19:52 UTC, Toralf Förster
Details
environment (environment,67.49 KB, text/plain)
2020-03-19 19:52 UTC, Toralf Förster
Details
etc.portage.tbz2 (etc.portage.tbz2,17.42 KB, application/x-bzip)
2020-03-19 19:52 UTC, Toralf Förster
Details
logs.tbz2 (logs.tbz2,553 bytes, application/x-bzip)
2020-03-19 19:52 UTC, Toralf Förster
Details
sys-libs:liburing-0.5:20200319-184216.log (sys-libs:liburing-0.5:20200319-184216.log,4.93 KB, text/plain)
2020-03-19 19:52 UTC, Toralf Förster
Details
temp.tbz2 (temp.tbz2,17.32 KB, application/x-bzip)
2020-03-19 19:52 UTC, Toralf Förster
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Toralf Förster gentoo-dev 2020-03-19 19:52:16 UTC
      |  ^~~~~~~
In file included from poll.c:15:
../src/include/liburing.h:325:35: error: unknown type name mode_t
  325 |      const char *path, int flags, mode_t mode)
      |                                   ^~~~~~
make[1]: *** [Makefile:34: poll] Error 1

  -------------------------------------------------------------------

  This is an unstable amd64 chroot image at a tinderbox (==build bot)
  name: 17.0_musl-20200316-165821

  -------------------------------------------------------------------

gcc-config -l:
 [1] x86_64-gentoo-linux-musl-9.3.0 *
clang version 10.0.0 
Target: x86_64-gentoo-linux-musl
Thread model: posix
InstalledDir: /usr/lib/llvm/10/bin
/usr/lib/llvm/10
10.0.0
Available Python interpreters, in order of preference:
  [1]   python3.8
  [2]   python3.7
  [3]   python3.6
  [4]   python2.7 (fallback)
Available Ruby profiles:
  [1]   ruby24 (with Rubygems)
  [2]   ruby25 (with Rubygems) *
Available Rust versions:
  [1]   rust-1.41.1 *

repository:
==> /var/db/repos/gentoo/metadata/timestamp.chk <==
Wed, 18 Mar 2020 13:38:27 +0000
emerge -qpvO sys-libs/liburing
[ebuild  N    ] sys-libs/liburing-0.5  USE="-static-libs"
Comment 1 Toralf Förster gentoo-dev 2020-03-19 19:52:20 UTC
Created attachment 622840 [details]
emerge-info.txt
Comment 2 Toralf Förster gentoo-dev 2020-03-19 19:52:23 UTC
Created attachment 622842 [details]
emerge-history.txt
Comment 3 Toralf Förster gentoo-dev 2020-03-19 19:52:26 UTC
Created attachment 622844 [details]
environment
Comment 4 Toralf Förster gentoo-dev 2020-03-19 19:52:31 UTC
Created attachment 622846 [details]
etc.portage.tbz2
Comment 5 Toralf Förster gentoo-dev 2020-03-19 19:52:33 UTC
Created attachment 622848 [details]
logs.tbz2
Comment 6 Toralf Förster gentoo-dev 2020-03-19 19:52:37 UTC
Created attachment 622850 [details]
sys-libs:liburing-0.5:20200319-184216.log
Comment 7 Toralf Förster gentoo-dev 2020-03-19 19:52:40 UTC
Created attachment 622852 [details]
temp.tbz2
Comment 8 Michael 'veremitz' Everitt 2020-03-27 13:20:08 UTC
According to similar bugs, it looks like something is missing #include <sys/stat.h> somewhere.
Comment 9 Sam James archtester gentoo-dev Security 2020-03-31 19:21:36 UTC
(In reply to Michael 'veremitz' Everitt from comment #8)
> According to similar bugs, it looks like something is missing #include
> <sys/stat.h> somewhere.

interestingly alpine aren't patching this: https://git.alpinelinux.org/aports/tree/testing/liburing?h=master w/ 0.5
Comment 10 David Duchesne 2020-11-12 14:19:41 UTC
In case it helps :
using sys-libs/liburing live ebuild
at latest commit :
https://github.com/axboe/liburing/commit/ba0a2e44b87525ad5d8fd5b04bee7a18fc39415c

fixes the issue.

Not ideal but for now, the latest tag is still 0.7
Comment 11 David Duchesne 2020-11-12 14:25:11 UTC
(In reply to David Duchesne from comment #10)
> In case it helps :
> using sys-libs/liburing live ebuild
> at latest commit :
> https://github.com/axboe/liburing/commit/
> ba0a2e44b87525ad5d8fd5b04bee7a18fc39415c
> 
> fixes the issue.
> 
> Not ideal but for now, the latest tag is still 0.7
Woops, well, just noticed this bug report was about liburing-0.5.
My build error (on musl) was somehow a little bit different with latest stable (0.7-r1), I will open a separate bug report. (using live ebuild still fixes it though, so maybe just need to wait a little bit for a new release)
Sorry about the noise.
Comment 12 ernsteiswuerfel archtester 2021-01-20 21:33:57 UTC
Interestingly for me a different upstream commit fixes the 0.7-r1 build issue: https://github.com/axboe/liburing/commit/1cf969dfcba797a02d74540965677b92d3884cfa

 examples: disable ucontext-cp if ucontext.h is not available

The header file `ucontext.h` is not available on musl based distros. The
example `ucontext-cp` is not built if `configure` fails to locate the
header.

live-ebuild is also ok, yes.
Comment 13 Jory A. Pratt gentoo-dev 2021-02-28 01:43:25 UTC
(In reply to ernsteiswuerfel from comment #12)
> Interestingly for me a different upstream commit fixes the 0.7-r1 build
> issue:
> https://github.com/axboe/liburing/commit/
> 1cf969dfcba797a02d74540965677b92d3884cfa
> 
>  examples: disable ucontext-cp if ucontext.h is not available
> 
> The header file `ucontext.h` is not available on musl based distros. The
> example `ucontext-cp` is not built if `configure` fails to locate the
> header.
> 
> live-ebuild is also ok, yes.

This is the correct patch. If maintainer wants to add it they can, if musl users will have to wait for the next release.
Comment 14 Lars Wendler (Polynomial-C) gentoo-dev 2021-03-11 18:31:48 UTC
Should be fixed.
Comment 15 Larry the Git Cow gentoo-dev 2021-03-12 15:06:53 UTC
The bug has been closed via the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=a76defdd03f53949133c2a18dec2ec2b8aa07ef6

commit a76defdd03f53949133c2a18dec2ec2b8aa07ef6
Author:     Jory Pratt <anarchy@gentoo.org>
AuthorDate: 2021-03-12 15:06:33 +0000
Commit:     Jory Pratt <anarchy@gentoo.org>
CommitDate: 2021-03-12 15:06:47 +0000

    sys-libs/liburing: add support to detect ucontext.h
    
    Closes: https://bugs.gentoo.org/713528
    Closes: https://github.com/gentoo/musl/issues/379
    Package-Manager: Portage-3.0.17, Repoman-3.0.2
    Signed-off-by: Jory Pratt <anarchy@gentoo.org>

 .../files/liburing-0.7-ucontext_h-detection.patch  | 72 ++++++++++++++++++++++
 sys-libs/liburing/liburing-0.7-r1.ebuild           |  6 +-
 2 files changed, 77 insertions(+), 1 deletion(-)